var ExtractionReg = function()
{
	var exreg = {};
	var debug = 0;
	
	var consumablesFileIsValid = false;
	var jsonConsumables = {};
	var jsonConsumablesOrig = {};
	var jsonConsumablesModified = {};
	var jsonKitArray = [];
	
	// Page initialization
	exreg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', exreg.validateStep1);
		//Events.addEventHandler('consumablesFile', 'change', exreg.consumablesFileOnChange);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', exreg.initializeStep2);
/*
		Events.addEventHandler('step-2', 'wizard-validate', exreg.validateStep2);
*/

		Buttons.addClickHandler('downloadLibPrepKitDataFile', exreg.downloadLibPrepKitDataFile);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
/*
		Buttons.addClickHandler('gocreate', exreg.createProtocol);
*/
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', exreg.submit);

		exreg.initializeStep1();
	}

	exreg.initializeStep1 = function()
	{
		var frm = document.forms['meludi'];
		Wizard.setCurrentStep(1);
		Doc.show('step-1');
		Doc.show('gonext');
	}

	exreg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
//alert("exreg.validateStep1(): consumablesFileIsValid = " + consumablesFileIsValid);
/*
		if (!consumablesFileIsValid)
		{
			event.preventDefault();
		}
		else
		{
			Wizard.setInputStatus('consumablesFile', 'valid');
		}
*/
	}
	
	exreg.consumablesFileOnChange = function()
	{
		var frm = document.forms['meludi'];
		var file = frm.consumablesFile.files[0];
		
		var reader = new FileReader();
		reader.onload = exreg.consumablesFileLoaded;
		reader.readAsText(file);
	}

	exreg.consumablesFileLoaded = function(event)
	{
		exreg.parseConsumablesFile(event.target.result);
	}

	exreg.parseConsumablesFile = function(data)
	{
		var frm = document.forms['meludi'];
		consumablesFileIsValid = false;

		// Column data are stored in JSONArrays
		var jsonHeaders = [];
		var jsonKitName = [];
		var jsonLibraryPrepBox1 = [];
		var jsonIndexKit = [];
		var jsonContentSetBox3 = [];
		var jsonOligoPoolA_FPA = [];
		var jsonOligoPoolB_FPB = [];
		var jsonOligoHybridizationSequencingReagent3 = [];
		var jsonStringentWash1_SW1 = [];
		var jsonExtensionLigationMix3 = [];
		var jsonPcrMasterMix2_PMM2 = [];
		var jsonUB1 = [];
		var jsonTDP = [];
		var jsonFilterplate = [];
		
		var jsonIndexPrimerA701 = [];
		var jsonIndexPrimerA702 = [];
		var jsonIndexPrimerA703 = [];
		var jsonIndexPrimerA704 = [];
		var jsonIndexPrimerA705 = [];
		var jsonIndexPrimerA706 = [];
		var jsonIndexPrimerA707 = [];
		var jsonIndexPrimerA708 = [];
		var jsonIndexPrimerA709 = [];
		var jsonIndexPrimerA710 = [];
		var jsonIndexPrimerA711 = [];
		var jsonIndexPrimerA712 = [];
		
		var jsonIndexPrimerA501 = [];
		var jsonIndexPrimerA502 = [];
		var jsonIndexPrimerA503 = [];
		var jsonIndexPrimerA504 = [];
		var jsonIndexPrimerA505 = [];
		var jsonIndexPrimerA506 = [];
		var jsonIndexPrimerA507 = [];
		var jsonIndexPrimerA508 = [];

		// Find column separator as first character after first occurrence of search string
		var separator = ExtractUtils.findSeparator(data, "Consumables");
		if (separator == null)
		{
			// Comma is default separator
			separator = ',';
		}
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): separator = \"" + separator + "\"");
		var columnSplitRegexp = new RegExp(" *" + separator + " *",'');
		var lines = data.split(/[\n\r]+/);
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): lines.length = " + lines.length);
		//var columns = lines[0].split(columnSplitRegexp);

		var numImported = 0;
		for (var i = 1; i < lines.length; i++)
		{
			if (lines[i].match(/^\s*$/)) continue; // Ignore empty lines
			var columns = lines[i].split(columnSplitRegexp);
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): i = " + i + " columns[0] = " + columns[0] + " columns[1] = " + columns[1]);
			// First column is either empty, or equal to barcode sequence for index primers
			header = columns[1];
			firstDataIndex = 2;
			// Skip lines without data
			if (header != '')
			{
				jsonHeaders[jsonHeaders.length] = header;

				for (var j = 0; j < (columns.length - firstDataIndex); j++)
				{
					var data = columns[firstDataIndex + j];
					if (header == 'TruSight Tumor Library Preparation partI')
					{
						jsonKitName[j] = data;
					}
					else if (header == 'TruSight Tumor Library Prep Box 1')
					{
						jsonLibraryPrepBox1[j] = data;
					}
					else if (header == 'TruSight Tumor Index Kit')
					{
						jsonIndexKit[j] = data;
					}
					else if (header == 'TruSight Tumor Content Set Box 3')
					{
						jsonContentSetBox3[j] = data;
					}
					else if (header == 'TruSight Tumor Oligo Pool A (FPA)')
					{
						jsonOligoPoolA_FPA[j] = data;
					}
					else if (header == 'TruSight Tumor Oligo Pool B (FPB)')
					{
						jsonOligoPoolB_FPB[j] = data;
					}
					else if (header == 'Oligo Hybridization for Sequencing Reagent 3 (OHS3)')
					{
						jsonOligoHybridizationSequencingReagent3[j] = data;
					}
					else if (header == 'Stringent Wash 1 (SW1)')
					{
						jsonStringentWash1_SW1[j] = data;
					}
					else if (header == 'Extension Ligation Mix 3 (ELM3)')
					{
						jsonExtensionLigationMix3[j] = data;
					}
					else if (header == 'PCR Master Mix 2 (PMM2)')
					{
						jsonPcrMasterMix2_PMM2[j] = data;
					}
					else if (header == 'UB1')
					{
						jsonUB1[j] = data;
					}
					else if (header == 'TDP')
					{
						jsonTDP[j] = data;
					}
					else if (header == 'Filterplate')
					{
						jsonFilterplate[j] = data;
					}
					else if (header == 'Index Primer A701')
					{
						jsonIndexPrimerA701[j] = data;
					}
					else if (header == 'Index Primer A702')
					{
						jsonIndexPrimerA702[j] = data;
					}
					else if (header == 'Index Primer A703')
					{
						jsonIndexPrimerA703[j] = data;
					}
					else if (header == 'Index Primer A704')
					{
						jsonIndexPrimerA704[j] = data;
					}
					else if (header == 'Index Primer A705')
					{
						jsonIndexPrimerA705[j] = data;
					}
					else if (header == 'Index Primer A706')
					{
						jsonIndexPrimerA706[j] = data;
					}
					else if (header == 'Index Primer A707')
					{
						jsonIndexPrimerA707[j] = data;
					}
					else if (header == 'Index Primer A708')
					{
						jsonIndexPrimerA708[j] = data;
					}
					else if (header == 'Index Primer A709')
					{
						jsonIndexPrimerA709[j] = data;
					}
					else if (header == 'Index Primer A710')
					{
						jsonIndexPrimerA710[j] = data;
					}
					else if (header == 'Index Primer A711')
					{
						jsonIndexPrimerA711[j] = data;
					}
					else if (header == 'Index Primer A712')
					{
						jsonIndexPrimerA712[j] = data;
					}
					else if (header == 'Index Primer A501')
					{
						jsonIndexPrimerA501[j] = data;
					}
					else if (header == 'Index Primer A502')
					{
						jsonIndexPrimerA502[j] = data;
					}
					else if (header == 'Index Primer A503')
					{
						jsonIndexPrimerA503[j] = data;
					}
					else if (header == 'Index Primer A504')
					{
						jsonIndexPrimerA504[j] = data;
					}
					else if (header == 'Index Primer A505')
					{
						jsonIndexPrimerA505[j] = data;
					}
					else if (header == 'Index Primer A506')
					{
						jsonIndexPrimerA506[j] = data;
					}
					else if (header == 'Index Primer A507')
					{
						jsonIndexPrimerA507[j] = data;
					}
					else if (header == 'Index Primer A508')
					{
						jsonIndexPrimerA508[j] = data;
					}
				}
			}
		}

		jsonConsumables['Headers'] = jsonHeaders;

		jsonConsumables['KitName'] = jsonKitName;
		jsonConsumables['LibraryPrepBox1'] = jsonLibraryPrepBox1;
		jsonConsumables['IndexKit'] = jsonIndexKit;
		jsonConsumables['ContentSetBox3'] = jsonContentSetBox3;
		jsonConsumables['OligoPoolA_FPA'] = jsonOligoPoolA_FPA;
		jsonConsumables['OligoPoolB_FPB'] = jsonOligoPoolB_FPB;
		jsonConsumables['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3;
		jsonConsumables['StringentWash1_SW1'] = jsonStringentWash1_SW1;
		jsonConsumables['ExtensionLigationMix3'] = jsonExtensionLigationMix3;
		jsonConsumables['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2;
		jsonConsumables['UB1'] = jsonUB1;
		jsonConsumables['TDP'] = jsonTDP;
		jsonConsumables['Filterplate'] = jsonFilterplate;

		jsonConsumables['IndexPrimerA701'] = jsonIndexPrimerA701;
		jsonConsumables['IndexPrimerA702'] = jsonIndexPrimerA702;
		jsonConsumables['IndexPrimerA703'] = jsonIndexPrimerA703;
		jsonConsumables['IndexPrimerA704'] = jsonIndexPrimerA704;
		jsonConsumables['IndexPrimerA705'] = jsonIndexPrimerA705;
		jsonConsumables['IndexPrimerA706'] = jsonIndexPrimerA706;
		jsonConsumables['IndexPrimerA707'] = jsonIndexPrimerA707;
		jsonConsumables['IndexPrimerA708'] = jsonIndexPrimerA708;
		jsonConsumables['IndexPrimerA709'] = jsonIndexPrimerA709;
		jsonConsumables['IndexPrimerA710'] = jsonIndexPrimerA710;
		jsonConsumables['IndexPrimerA711'] = jsonIndexPrimerA711;
		jsonConsumables['IndexPrimerA712'] = jsonIndexPrimerA712;

		jsonConsumables['IndexPrimerA501'] = jsonIndexPrimerA501;
		jsonConsumables['IndexPrimerA502'] = jsonIndexPrimerA502;
		jsonConsumables['IndexPrimerA503'] = jsonIndexPrimerA503;
		jsonConsumables['IndexPrimerA504'] = jsonIndexPrimerA504;
		jsonConsumables['IndexPrimerA505'] = jsonIndexPrimerA505;
		jsonConsumables['IndexPrimerA506'] = jsonIndexPrimerA506;
		jsonConsumables['IndexPrimerA507'] = jsonIndexPrimerA507;
		jsonConsumables['IndexPrimerA508'] = jsonIndexPrimerA508;

		Wizard.setInputStatus('consumablesFile', 'valid');
		consumablesFileIsValid = true;
	}

	exreg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLibPrepKitData';
		url += '&libPrepKitFilter='+encodeURIComponent(frm.libPrepKitFilter.value);
		Wizard.showLoadingAnimation('Getting kit data...');
		Wizard.asyncJsonRequest(url, exreg.libPrepKitDataResults);
	}

	exreg.libPrepKitDataResults = function(response)
	{
		jsonConsumables = response.consumables;
		// Make copy of original values
		jsonConsumablesOrig = exreg.copyJsonConsumables(jsonConsumables);

		exreg.updateDetailsTable();
	}

	exreg.updateDetailsTable = function()
	{
		var frm = document.forms['meludi'];

		// Store data one kit a time, i.e. 'jsonKitArray' is a JSONArray with one JSONObject for each kit
		//exreg.libPrepKitDataToJsonArray();

		var kitFilterValue = frm.libPrepKitFilter.value;
		var kitFilterName = exreg.fetchLibPrepFilterName(kitFilterValue);
		var numItemsFiltered = jsonConsumables['numItemsFiltered'];
		var numItemsTot = jsonConsumables['numItemsTot'];
		Doc.element('libPrepKitFilterName').innerHTML = '<b>Library preparation kit filter: ' + kitFilterName + '</b>';
		Doc.element('libPrepKitFilterName').innerHTML += '&nbsp;&nbsp;(' + numItemsFiltered + '&nbsp;of&nbsp;' + numItemsTot + ')';
		var html = '<table id="detailsTable" class="step-form">';

		// First header row
		html += '<thead>';
		html += '<tr>';
		html += '<th></th>';
		//
		html += '<th>TruSight Tumor Library Preparation partI</th>';
		//
		html += '<td class="dottedleft">Registration date</td>';
		html += '<td class="dottedleft">Last updated</td>';
		html += '<td class="dottedleft">Expiration date</td>';
		html += '<td class="dottedleft">Active</td>';
		html += '<td class="dottedleft">#Times used</td>';
		html += '<td class="dottedleft">Unused FPA plate locations</td>';
		html += '<td class="dottedleft">Comment</td>';
		//
		html += '<th class="dottedleft">TruSight Tumor Library Prep Box 1</th>';
		html += '<th class="dottedleft">TruSight Tumor Index Kit</th>';
		html += '<th class="dottedleft">TruSight Tumor Content Set Box 3</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool A (FPA)</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool B (FPB)</th>';
		html += '<th class="dottedleft">Oligo Hybridization for Sequencing Reagent 3 (OHS3)</th>';
		html += '<th class="dottedleft">Stringent Wash 1 (SW1)</th>';
		html += '<th class="dottedleft">Extension Ligation Mix 3 (ELM3)</th>';
		html += '<th class="dottedleft">PCR Master Mix 2 (PMM2)</th>';
		html += '<th class="dottedleft">UB1</th>';
		html += '<th class="dottedleft">TDP</th>';
		html += '<th class="dottedleft">Filterplate</th>';
		html += '<th colspan="12" class="dottedleft">Index 1 Primers Lot Number</th>';
		html += '<th colspan="8" class="dottedleft">Index 2 Primers Lot Number</th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th></th>';

		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">ATCACGAC</td>';
		html += '<td class="dottedleft">ACAGTGGT</td>';
		html += '<td class="dottedleft">CAGATCCA</td>';
		html += '<td class="dottedleft">ACAAACGG</td>';
		html += '<td class="dottedleft">ACCCAGCA</td>';
		html += '<td class="dottedleft">AACCCCTC</td>';
		html += '<td class="dottedleft">CCCAACCT</td>';
		html += '<td class="dottedleft">CACCACAC</td>';
		html += '<td class="dottedleft">GAAACCCA</td>';
		html += '<td class="dottedleft">TGTGACCA</td>';
		html += '<td class="dottedleft">AGGGTCAA</td>';
		html += '<td class="dottedleft">AGGAGTGG</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">TGAACCTT</td>';
		html += '<td class="dottedleft">TGCTAAGT</td>';
		html += '<td class="dottedleft">TGTTCTCT</td>';
		html += '<td class="dottedleft">TAAGACAC</td>';
		html += '<td class="dottedleft">CTAATCGA</td>';
		html += '<td class="dottedleft">CTAGAACA</td>';
		html += '<td class="dottedleft">TAAGTTCC</td>';
		html += '<td class="dottedleft">TAGACCTA</td>';
		html += '</tr>';
		// Third header row
		html += '<tr>';
		html += '<th></th>';

		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">A701</td>';
		html += '<td class="dottedleft">A702</td>';
		html += '<td class="dottedleft">A703</td>';
		html += '<td class="dottedleft">A704</td>';
		html += '<td class="dottedleft">A705</td>';
		html += '<td class="dottedleft">A706</td>';
		html += '<td class="dottedleft">A707</td>';
		html += '<td class="dottedleft">A708</td>';
		html += '<td class="dottedleft">A709</td>';
		html += '<td class="dottedleft">A710</td>';
		html += '<td class="dottedleft">A711</td>';
		html += '<td class="dottedleft">A712</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">A501</td>';
		html += '<td class="dottedleft">A502</td>';
		html += '<td class="dottedleft">A503</td>';
		html += '<td class="dottedleft">A504</td>';
		html += '<td class="dottedleft">A505</td>';
		html += '<td class="dottedleft">A506</td>';
		html += '<td class="dottedleft">A507</td>';
		html += '<td class="dottedleft">A508</td>';
		//
		html += '</tr>';
		html += '</thead>';
		html += '<tbody>';

		// Get JSONArrays with data for kits

		var jsonHeaders = jsonConsumables['Headers'];

		var jsonKitName = jsonConsumables['KitName'];

		var jsonRegistrationDate = jsonConsumables['RegistrationDate'];
		var jsonLastUpdatedDate = jsonConsumables['LastUpdatedDate'];
		var jsonExpirationDate = jsonConsumables['ExpirationDate'];
		var jsonActive = jsonConsumables['Active'];
		var jsonTimesUsed = jsonConsumables['TimesUsed'];
		var jsonUnusedFpaPlateLocs = jsonConsumables['UnusedFpaPlateLocs'];
		var jsonComment = jsonConsumables['Comment'];

		var jsonLibraryPrepBox1 = jsonConsumables['LibraryPrepBox1'];
		var jsonIndexKit = jsonConsumables['IndexKit'];
		var jsonContentSetBox3 = jsonConsumables['ContentSetBox3'];
		var jsonOligoPoolA_FPA = jsonConsumables['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPB = jsonConsumables['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3 = jsonConsumables['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1 = jsonConsumables['StringentWash1_SW1'];
		var jsonExtensionLigationMix3 = jsonConsumables['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2 = jsonConsumables['PcrMasterMix2_PMM2'];
		var jsonUB1 = jsonConsumables['UB1'];
		var jsonTDP = jsonConsumables['TDP'];
		var jsonFilterplate = jsonConsumables['Filterplate'];
		
		var jsonIndexPrimerA701 = jsonConsumables['IndexPrimerA701'];
		var jsonIndexPrimerA702 = jsonConsumables['IndexPrimerA702'];
		var jsonIndexPrimerA703 = jsonConsumables['IndexPrimerA703'];
		var jsonIndexPrimerA704 = jsonConsumables['IndexPrimerA704'];
		var jsonIndexPrimerA705 = jsonConsumables['IndexPrimerA705'];
		var jsonIndexPrimerA706 = jsonConsumables['IndexPrimerA706'];
		var jsonIndexPrimerA707 = jsonConsumables['IndexPrimerA707'];
		var jsonIndexPrimerA708 = jsonConsumables['IndexPrimerA708'];
		var jsonIndexPrimerA709 = jsonConsumables['IndexPrimerA709'];
		var jsonIndexPrimerA710 = jsonConsumables['IndexPrimerA710'];
		var jsonIndexPrimerA711 = jsonConsumables['IndexPrimerA711'];
		var jsonIndexPrimerA712 = jsonConsumables['IndexPrimerA712'];
		
		var jsonIndexPrimerA501 = jsonConsumables['IndexPrimerA501'];
		var jsonIndexPrimerA502 = jsonConsumables['IndexPrimerA502'];
		var jsonIndexPrimerA503 = jsonConsumables['IndexPrimerA503'];
		var jsonIndexPrimerA504 = jsonConsumables['IndexPrimerA504'];
		var jsonIndexPrimerA505 = jsonConsumables['IndexPrimerA505'];
		var jsonIndexPrimerA506 = jsonConsumables['IndexPrimerA506'];
		var jsonIndexPrimerA507 = jsonConsumables['IndexPrimerA507'];
		var jsonIndexPrimerA508 = jsonConsumables['IndexPrimerA508'];

		var numItems = jsonKitName.length;

		for (var i = 0; i < numItems; i++)
		{
			var activeStr = 'yes';
			if (!jsonActive[i])
			{
				activeStr = 'no';
			}
			var timesUsed = '' + jsonTimesUsed[i];

			html += '<tr class="highlight">';
			// Add edit button
			html += '<td><div class="button basicbutton interactable edit-details" style="width: 5em;" data-index="'+i+'">Edit&hellip;</div></td>';

			html += '<th class="dottedleft" id="kitName'+i+'">' + Strings.encodeTags(jsonKitName[i]) + '</th>';

			html += '<td class="dottedleft" id="registrationDate'+i+'">' + Strings.encodeTags(jsonRegistrationDate[i]) + '</td>';
			html += '<td class="dottedleft" id="lastUpdatedDate'+i+'">' + Strings.encodeTags(jsonLastUpdatedDate[i]) + '</td>';
			html += '<td class="dottedleft" id="expirationDate'+i+'">' + Strings.encodeTags(jsonExpirationDate[i]) + '</td>';
			html += '<td class="dottedleft" id="active'+i+'">' + Strings.encodeTags(activeStr) + '</td>';
			html += '<td class="dottedleft" id="numTimesUsed'+i+'">' + Strings.encodeTags(timesUsed) + '</td>';
			html += '<td class="dottedleft" id="unusedFpaLoc'+i+'">' + Strings.encodeTags(jsonUnusedFpaPlateLocs[i]) + '</td>';
			html += '<td class="dottedleft" id="kitComment'+i+'">' + Strings.encodeTags(jsonComment[i]) + '</td>';

			html += '<td class="dottedleft" id="libraryPrepBox1'+i+'">' + Strings.encodeTags(jsonLibraryPrepBox1[i]) + '</td>';
			html += '<td class="dottedleft" id="indexKit'+i+'">' + Strings.encodeTags(jsonIndexKit[i]) + '</td>';
			html += '<td class="dottedleft" id="contentSetBox3'+i+'">' + Strings.encodeTags(jsonContentSetBox3[i]) + '</td>';
			html += '<td class="dottedleft" id="oligoPoolA_FPA'+i+'">' + Strings.encodeTags(jsonOligoPoolA_FPA[i]) + '</td>';
			html += '<td class="dottedleft" id="oligoPoolB_FPB'+i+'">' + Strings.encodeTags(jsonOligoPoolB_FPB[i]) + '</td>';
			html += '<td class="dottedleft" id="oligoHybridizationSequencingReagent3'+i+'">' + Strings.encodeTags(jsonOligoHybridizationSequencingReagent3[i]) + '</td>';
			html += '<td class="dottedleft" id="stringentWash1_SW1'+i+'">' + Strings.encodeTags(jsonStringentWash1_SW1[i]) + '</td>';
			html += '<td class="dottedleft" id="extensionLigationMix3'+i+'">' + Strings.encodeTags(jsonExtensionLigationMix3[i]) + '</td>';
			html += '<td class="dottedleft" id="pcrMasterMix2_PMM2'+i+'">' + Strings.encodeTags(jsonPcrMasterMix2_PMM2[i]) + '</td>';
			html += '<td class="dottedleft" id="ub1'+i+'">' + Strings.encodeTags(jsonUB1[i]) + '</td>';
			html += '<td class="dottedleft" id="tdp'+i+'">' + Strings.encodeTags(jsonTDP[i]) + '</td>';
			html += '<td class="dottedleft" id="filterplate'+i+'">' + Strings.encodeTags(jsonFilterplate[i]) + '</td>';

			html += '<td class="dottedleft" id="indexPrimerA701'+i+'">' + Strings.encodeTags(jsonIndexPrimerA701[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA702'+i+'">' + Strings.encodeTags(jsonIndexPrimerA702[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA703'+i+'">' + Strings.encodeTags(jsonIndexPrimerA703[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA704'+i+'">' + Strings.encodeTags(jsonIndexPrimerA704[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA705'+i+'">' + Strings.encodeTags(jsonIndexPrimerA705[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA706'+i+'">' + Strings.encodeTags(jsonIndexPrimerA706[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA707'+i+'">' + Strings.encodeTags(jsonIndexPrimerA707[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA708'+i+'">' + Strings.encodeTags(jsonIndexPrimerA708[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA709'+i+'">' + Strings.encodeTags(jsonIndexPrimerA709[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA710'+i+'">' + Strings.encodeTags(jsonIndexPrimerA710[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA711'+i+'">' + Strings.encodeTags(jsonIndexPrimerA711[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA712'+i+'">' + Strings.encodeTags(jsonIndexPrimerA712[i]) + '</td>';

			html += '<td class="dottedleft" id="indexPrimerA501'+i+'">' + Strings.encodeTags(jsonIndexPrimerA501[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA502'+i+'">' + Strings.encodeTags(jsonIndexPrimerA502[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA503'+i+'">' + Strings.encodeTags(jsonIndexPrimerA503[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA504'+i+'">' + Strings.encodeTags(jsonIndexPrimerA504[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA505'+i+'">' + Strings.encodeTags(jsonIndexPrimerA505[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA506'+i+'">' + Strings.encodeTags(jsonIndexPrimerA506[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA507'+i+'">' + Strings.encodeTags(jsonIndexPrimerA507[i]) + '</td>';
			html += '<td class="dottedleft" id="indexPrimerA508'+i+'">' + Strings.encodeTags(jsonIndexPrimerA508[i]) + '</td>';

			// Add edit button
			html += '<td><div class="button basicbutton interactable edit-details" style="width: 5em;" data-index="'+i+'">Edit&hellip;</div></td>';

			html += '</tr>';
		}
		html += '</tbody>';
		html += '</table>';
		Doc.element('detailsSection').innerHTML = html;

		// Highlight modified items
		
		var jsonRegistrationDateOrig = jsonConsumablesOrig['RegistrationDate'];
		var jsonLastUpdatedDateOrig = jsonConsumablesOrig['LastUpdatedDate'];
		var jsonExpirationDateOrig = jsonConsumablesOrig['ExpirationDate'];
		var jsonActiveOrig = jsonConsumablesOrig['Active'];
		var jsonTimesUsedOrig = jsonConsumablesOrig['TimesUsed'];
		var jsonUnusedFpaPlateLocsOrig = jsonConsumablesOrig['UnusedFpaPlateLocs'];
		var jsonCommentOrig = jsonConsumablesOrig['Comment'];

		var jsonLibraryPrepBox1Orig = jsonConsumablesOrig['LibraryPrepBox1'];
		var jsonIndexKitOrig = jsonConsumablesOrig['IndexKit'];
		var jsonContentSetBox3Orig = jsonConsumablesOrig['ContentSetBox3'];
		var jsonOligoPoolA_FPAOrig = jsonConsumablesOrig['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPBOrig = jsonConsumablesOrig['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3Orig = jsonConsumablesOrig['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1Orig = jsonConsumablesOrig['StringentWash1_SW1'];
		var jsonExtensionLigationMix3Orig = jsonConsumablesOrig['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2Orig = jsonConsumablesOrig['PcrMasterMix2_PMM2'];
		var jsonUB1Orig = jsonConsumablesOrig['UB1'];
		var jsonTDPOrig = jsonConsumablesOrig['TDP'];
		var jsonFilterplateOrig = jsonConsumablesOrig['Filterplate'];
		
		var jsonIndexPrimerA701Orig = jsonConsumablesOrig['IndexPrimerA701'];
		var jsonIndexPrimerA702Orig = jsonConsumablesOrig['IndexPrimerA702'];
		var jsonIndexPrimerA703Orig = jsonConsumablesOrig['IndexPrimerA703'];
		var jsonIndexPrimerA704Orig = jsonConsumablesOrig['IndexPrimerA704'];
		var jsonIndexPrimerA705Orig = jsonConsumablesOrig['IndexPrimerA705'];
		var jsonIndexPrimerA706Orig = jsonConsumablesOrig['IndexPrimerA706'];
		var jsonIndexPrimerA707Orig = jsonConsumablesOrig['IndexPrimerA707'];
		var jsonIndexPrimerA708Orig = jsonConsumablesOrig['IndexPrimerA708'];
		var jsonIndexPrimerA709Orig = jsonConsumablesOrig['IndexPrimerA709'];
		var jsonIndexPrimerA710Orig = jsonConsumablesOrig['IndexPrimerA710'];
		var jsonIndexPrimerA711Orig = jsonConsumablesOrig['IndexPrimerA711'];
		var jsonIndexPrimerA712Orig = jsonConsumablesOrig['IndexPrimerA712'];
		
		var jsonIndexPrimerA501Orig = jsonConsumablesOrig['IndexPrimerA501'];
		var jsonIndexPrimerA502Orig = jsonConsumablesOrig['IndexPrimerA502'];
		var jsonIndexPrimerA503Orig = jsonConsumablesOrig['IndexPrimerA503'];
		var jsonIndexPrimerA504Orig = jsonConsumablesOrig['IndexPrimerA504'];
		var jsonIndexPrimerA505Orig = jsonConsumablesOrig['IndexPrimerA505'];
		var jsonIndexPrimerA506Orig = jsonConsumablesOrig['IndexPrimerA506'];
		var jsonIndexPrimerA507Orig = jsonConsumablesOrig['IndexPrimerA507'];
		var jsonIndexPrimerA508Orig = jsonConsumablesOrig['IndexPrimerA508'];

		for (var i = 0; i < numItems; i++)
		{
			// Test of modification highlight
			Doc.addOrRemoveClass('registrationDate'+i, 'nondefault', jsonRegistrationDate[i] != jsonRegistrationDateOrig[i]);
			Doc.addOrRemoveClass('lastUpdatedDate'+i, 'nondefault', jsonLastUpdatedDate[i] != jsonLastUpdatedDateOrig[i]);
			Doc.addOrRemoveClass('expirationDate'+i, 'nondefault', jsonExpirationDate[i] != jsonExpirationDateOrig[i]);
			Doc.addOrRemoveClass('active'+i, 'nondefault', jsonActive[i] != jsonActiveOrig[i]);
			Doc.addOrRemoveClass('numTimesUsed'+i, 'nondefault', jsonTimesUsed[i] != jsonTimesUsedOrig[i]);
			Doc.addOrRemoveClass('unusedFpaLoc'+i, 'nondefault', jsonUnusedFpaPlateLocs[i] != jsonUnusedFpaPlateLocsOrig[i]);
			Doc.addOrRemoveClass('kitComment'+i, 'nondefault', jsonComment[i] != jsonCommentOrig[i]);

			Doc.addOrRemoveClass('libraryPrepBox1'+i, 'nondefault', jsonLibraryPrepBox1[i] != jsonLibraryPrepBox1Orig[i]);
			Doc.addOrRemoveClass('indexKit'+i, 'nondefault', jsonIndexKit[i] != jsonIndexKitOrig[i]);
			Doc.addOrRemoveClass('contentSetBox3'+i, 'nondefault', jsonContentSetBox3[i] != jsonContentSetBox3Orig[i]);
			Doc.addOrRemoveClass('oligoPoolA_FPA'+i, 'nondefault', jsonOligoPoolA_FPA[i] != jsonOligoPoolA_FPAOrig[i]);
			Doc.addOrRemoveClass('oligoPoolB_FPB'+i, 'nondefault', jsonOligoPoolB_FPB[i] != jsonOligoPoolB_FPBOrig[i]);
			Doc.addOrRemoveClass('oligoHybridizationSequencingReagent3'+i, 'nondefault', jsonOligoHybridizationSequencingReagent3[i] != jsonOligoHybridizationSequencingReagent3Orig[i]);
			Doc.addOrRemoveClass('stringentWash1_SW1'+i, 'nondefault', jsonStringentWash1_SW1[i] != jsonStringentWash1_SW1Orig[i]);
			Doc.addOrRemoveClass('extensionLigationMix3'+i, 'nondefault', jsonExtensionLigationMix3[i] != jsonExtensionLigationMix3Orig[i]);
			Doc.addOrRemoveClass('pcrMasterMix2_PMM2'+i, 'nondefault', jsonPcrMasterMix2_PMM2[i] != jsonPcrMasterMix2_PMM2Orig[i]);
			Doc.addOrRemoveClass('ub1'+i, 'nondefault', jsonUB1[i] != jsonUB1Orig[i]);
			Doc.addOrRemoveClass('tdp'+i, 'nondefault', jsonTDP[i] != jsonTDPOrig[i]);
			Doc.addOrRemoveClass('filterplate'+i, 'nondefault', jsonFilterplate[i] != jsonFilterplateOrig[i]);

			Doc.addOrRemoveClass('indexPrimerA701'+i, 'nondefault', jsonIndexPrimerA701[i] != jsonIndexPrimerA701Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA702'+i, 'nondefault', jsonIndexPrimerA702[i] != jsonIndexPrimerA702Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA703'+i, 'nondefault', jsonIndexPrimerA703[i] != jsonIndexPrimerA703Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA704'+i, 'nondefault', jsonIndexPrimerA704[i] != jsonIndexPrimerA704Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA705'+i, 'nondefault', jsonIndexPrimerA705[i] != jsonIndexPrimerA705Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA706'+i, 'nondefault', jsonIndexPrimerA706[i] != jsonIndexPrimerA706Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA707'+i, 'nondefault', jsonIndexPrimerA707[i] != jsonIndexPrimerA707Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA708'+i, 'nondefault', jsonIndexPrimerA708[i] != jsonIndexPrimerA708Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA709'+i, 'nondefault', jsonIndexPrimerA709[i] != jsonIndexPrimerA709Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA710'+i, 'nondefault', jsonIndexPrimerA710[i] != jsonIndexPrimerA710Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA711'+i, 'nondefault', jsonIndexPrimerA711[i] != jsonIndexPrimerA711Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA712'+i, 'nondefault', jsonIndexPrimerA712[i] != jsonIndexPrimerA712Orig[i]);

			Doc.addOrRemoveClass('indexPrimerA501'+i, 'nondefault', jsonIndexPrimerA501[i] != jsonIndexPrimerA501Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA502'+i, 'nondefault', jsonIndexPrimerA502[i] != jsonIndexPrimerA502Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA503'+i, 'nondefault', jsonIndexPrimerA503[i] != jsonIndexPrimerA503Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA504'+i, 'nondefault', jsonIndexPrimerA504[i] != jsonIndexPrimerA504Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA505'+i, 'nondefault', jsonIndexPrimerA505[i] != jsonIndexPrimerA505Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA506'+i, 'nondefault', jsonIndexPrimerA506[i] != jsonIndexPrimerA506Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA507'+i, 'nondefault', jsonIndexPrimerA507[i] != jsonIndexPrimerA507Orig[i]);
			Doc.addOrRemoveClass('indexPrimerA508'+i, 'nondefault', jsonIndexPrimerA508[i] != jsonIndexPrimerA508Orig[i]);
		}

		// Collect data for modified kits

		var jsonKitNameModified = [];

		var jsonRegistrationDateModified = [];
		var jsonLastUpdatedDateModified = [];
		var jsonExpirationDateModified = [];
		var jsonActiveModified = [];
		var jsonTimesUsedModified = [];
		var jsonUnusedFpaPlateLocsModified = [];
		var jsonCommentModified = [];

		var jsonLibraryPrepBox1Modified = [];
		var jsonIndexKitModified = [];
		var jsonContentSetBox3Modified = [];
		var jsonOligoPoolA_FPAModified = [];
		var jsonOligoPoolB_FPBModified = [];
		var jsonOligoHybridizationSequencingReagent3Modified = [];
		var jsonStringentWash1_SW1Modified = [];
		var jsonExtensionLigationMix3Modified = [];
		var jsonPcrMasterMix2_PMM2Modified = [];
		var jsonUB1Modified = [];
		var jsonTDPModified = [];
		var jsonFilterplateModified = [];
		
		var jsonIndexPrimerA701Modified = [];
		var jsonIndexPrimerA702Modified = [];
		var jsonIndexPrimerA703Modified = [];
		var jsonIndexPrimerA704Modified = [];
		var jsonIndexPrimerA705Modified = [];
		var jsonIndexPrimerA706Modified = [];
		var jsonIndexPrimerA707Modified = [];
		var jsonIndexPrimerA708Modified = [];
		var jsonIndexPrimerA709Modified = [];
		var jsonIndexPrimerA710Modified = [];
		var jsonIndexPrimerA711Modified = [];
		var jsonIndexPrimerA712Modified = [];
		
		var jsonIndexPrimerA501Modified = [];
		var jsonIndexPrimerA502Modified = [];
		var jsonIndexPrimerA503Modified = [];
		var jsonIndexPrimerA504Modified = [];
		var jsonIndexPrimerA505Modified = [];
		var jsonIndexPrimerA506Modified = [];
		var jsonIndexPrimerA507Modified = [];
		var jsonIndexPrimerA508Modified = [];

		var someKitIsModified = false;
		var numKitsModified = 0;
		for (var i = 0; i < numItems; i++)
		{
			// Check if data for kit has been modified
			var kitIsModified = false;

			if (jsonRegistrationDate[i] != jsonRegistrationDateOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonLastUpdatedDate[i] != jsonLastUpdatedDateOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonExpirationDate[i] != jsonExpirationDateOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonActive[i] != jsonActiveOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonTimesUsed[i] != jsonTimesUsedOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonUnusedFpaPlateLocs[i] != jsonUnusedFpaPlateLocsOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonComment[i] != jsonCommentOrig[i])
			{
				kitIsModified = true;
			}

			else if (jsonLibraryPrepBox1[i] != jsonLibraryPrepBox1Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexKit[i] != jsonIndexKitOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonContentSetBox3[i] != jsonContentSetBox3Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonOligoPoolA_FPA[i] != jsonOligoPoolA_FPAOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonOligoPoolB_FPB[i] != jsonOligoPoolB_FPBOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonOligoHybridizationSequencingReagent3[i] != jsonOligoHybridizationSequencingReagent3Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonStringentWash1_SW1[i] != jsonStringentWash1_SW1Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonExtensionLigationMix3[i] != jsonExtensionLigationMix3Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonPcrMasterMix2_PMM2[i] != jsonPcrMasterMix2_PMM2Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonUB1[i] != jsonUB1Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonTDP[i] != jsonTDPOrig[i])
			{
				kitIsModified = true;
			}
			else if (jsonFilterplate[i] != jsonFilterplateOrig[i])
			{
				kitIsModified = true;
			}

			else if (jsonIndexPrimerA701[i] != jsonIndexPrimerA701Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA702[i] != jsonIndexPrimerA702Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA703[i] != jsonIndexPrimerA703Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA704[i] != jsonIndexPrimerA704Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA705[i] != jsonIndexPrimerA705Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA706[i] != jsonIndexPrimerA706Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA707[i] != jsonIndexPrimerA707Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA708[i] != jsonIndexPrimerA708Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA709[i] != jsonIndexPrimerA709Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA710[i] != jsonIndexPrimerA710Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA711[i] != jsonIndexPrimerA711Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA712[i] != jsonIndexPrimerA712Orig[i])
			{
				kitIsModified = true;
			}

			else if (jsonIndexPrimerA501[i] != jsonIndexPrimerA501Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA502[i] != jsonIndexPrimerA502Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA503[i] != jsonIndexPrimerA503Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA504[i] != jsonIndexPrimerA504Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA505[i] != jsonIndexPrimerA505Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA506[i] != jsonIndexPrimerA506Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA507[i] != jsonIndexPrimerA507Orig[i])
			{
				kitIsModified = true;
			}
			else if (jsonIndexPrimerA508[i] != jsonIndexPrimerA508Orig[i])
			{
				kitIsModified = true;
			}

			if (kitIsModified)
			{
				someKitIsModified = true;
				// Store data for modified kit

				jsonKitNameModified[numKitsModified] = jsonKitName[i];

				jsonRegistrationDateModified[numKitsModified] = jsonRegistrationDate[i];
				jsonLastUpdatedDateModified[numKitsModified] = jsonLastUpdatedDate[i];
				jsonExpirationDateModified[numKitsModified] = jsonExpirationDate[i];
				jsonActiveModified[numKitsModified] = jsonActive[i];
				jsonTimesUsedModified[numKitsModified] = jsonTimesUsed[i];
				jsonUnusedFpaPlateLocsModified[numKitsModified] = jsonUnusedFpaPlateLocs[i];
				jsonCommentModified[numKitsModified] = jsonComment[i];

				jsonLibraryPrepBox1Modified[numKitsModified] = jsonLibraryPrepBox1[i];
				jsonIndexKitModified[numKitsModified] = jsonIndexKit[i];
				jsonContentSetBox3Modified[numKitsModified] = jsonContentSetBox3[i];
				jsonOligoPoolA_FPAModified[numKitsModified] = jsonOligoPoolA_FPA[i];
				jsonOligoPoolB_FPBModified[numKitsModified] = jsonOligoPoolB_FPB[i];
				jsonOligoHybridizationSequencingReagent3Modified[numKitsModified] = jsonOligoHybridizationSequencingReagent3[i];
				jsonStringentWash1_SW1Modified[numKitsModified] = jsonStringentWash1_SW1[i];
				jsonExtensionLigationMix3Modified[numKitsModified] = jsonExtensionLigationMix3[i];
				jsonPcrMasterMix2_PMM2Modified[numKitsModified] = jsonPcrMasterMix2_PMM2[i];
				jsonUB1Modified[numKitsModified] = jsonUB1[i];
				jsonTDPModified[numKitsModified] = jsonTDP[i];
				jsonFilterplateModified[numKitsModified] = jsonFilterplate[i];
		
				jsonIndexPrimerA701Modified[numKitsModified] = jsonIndexPrimerA701[i];
				jsonIndexPrimerA702Modified[numKitsModified] = jsonIndexPrimerA702[i];
				jsonIndexPrimerA703Modified[numKitsModified] = jsonIndexPrimerA703[i];
				jsonIndexPrimerA704Modified[numKitsModified] = jsonIndexPrimerA704[i];
				jsonIndexPrimerA705Modified[numKitsModified] = jsonIndexPrimerA705[i];
				jsonIndexPrimerA706Modified[numKitsModified] = jsonIndexPrimerA706[i];
				jsonIndexPrimerA707Modified[numKitsModified] = jsonIndexPrimerA707[i];
				jsonIndexPrimerA708Modified[numKitsModified] = jsonIndexPrimerA708[i];
				jsonIndexPrimerA709Modified[numKitsModified] = jsonIndexPrimerA709[i];
				jsonIndexPrimerA710Modified[numKitsModified] = jsonIndexPrimerA710[i];
				jsonIndexPrimerA711Modified[numKitsModified] = jsonIndexPrimerA711[i];
				jsonIndexPrimerA712Modified[numKitsModified] = jsonIndexPrimerA712[i];
		
				jsonIndexPrimerA501Modified[numKitsModified] = jsonIndexPrimerA501[i];
				jsonIndexPrimerA502Modified[numKitsModified] = jsonIndexPrimerA502[i];
				jsonIndexPrimerA503Modified[numKitsModified] = jsonIndexPrimerA503[i];
				jsonIndexPrimerA504Modified[numKitsModified] = jsonIndexPrimerA504[i];
				jsonIndexPrimerA505Modified[numKitsModified] = jsonIndexPrimerA505[i];
				jsonIndexPrimerA506Modified[numKitsModified] = jsonIndexPrimerA506[i];
				jsonIndexPrimerA507Modified[numKitsModified] = jsonIndexPrimerA507[i];
				jsonIndexPrimerA508Modified[numKitsModified] = jsonIndexPrimerA508[i];

				numKitsModified++;
			}
		}
		jsonConsumablesModified = {};

		jsonConsumablesModified['Headers'] = jsonHeaders;

		jsonConsumablesModified['KitName'] = jsonKitNameModified;

		jsonConsumablesModified['RegistrationDate'] = jsonRegistrationDateModified;
		jsonConsumablesModified['LastUpdatedDate'] = jsonLastUpdatedDateModified;
		jsonConsumablesModified['ExpirationDate'] = jsonExpirationDateModified;
		jsonConsumablesModified['Active'] = jsonActiveModified;
		jsonConsumablesModified['TimesUsed'] = jsonTimesUsedModified;
		jsonConsumablesModified['UnusedFpaPlateLocs'] = jsonUnusedFpaPlateLocsModified;
		jsonConsumablesModified['Comment'] = jsonCommentModified;

		jsonConsumablesModified['LibraryPrepBox1'] = jsonLibraryPrepBox1Modified;
		jsonConsumablesModified['IndexKit'] = jsonIndexKitModified;
		jsonConsumablesModified['ContentSetBox3'] = jsonContentSetBox3Modified;
		jsonConsumablesModified['OligoPoolA_FPA'] = jsonOligoPoolA_FPAModified;
		jsonConsumablesModified['OligoPoolB_FPB'] = jsonOligoPoolB_FPBModified;
		jsonConsumablesModified['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3Modified;
		jsonConsumablesModified['StringentWash1_SW1'] = jsonStringentWash1_SW1Modified;
		jsonConsumablesModified['ExtensionLigationMix3'] = jsonExtensionLigationMix3Modified;
		jsonConsumablesModified['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2Modified;
		jsonConsumablesModified['UB1'] = jsonUB1Modified;
		jsonConsumablesModified['TDP'] = jsonTDPModified;
		jsonConsumablesModified['Filterplate'] = jsonFilterplateModified;

		jsonConsumablesModified['IndexPrimerA701'] = jsonIndexPrimerA701Modified;
		jsonConsumablesModified['IndexPrimerA702'] = jsonIndexPrimerA702Modified;
		jsonConsumablesModified['IndexPrimerA703'] = jsonIndexPrimerA703Modified;
		jsonConsumablesModified['IndexPrimerA704'] = jsonIndexPrimerA704Modified;
		jsonConsumablesModified['IndexPrimerA705'] = jsonIndexPrimerA705Modified;
		jsonConsumablesModified['IndexPrimerA706'] = jsonIndexPrimerA706Modified;
		jsonConsumablesModified['IndexPrimerA707'] = jsonIndexPrimerA707Modified;
		jsonConsumablesModified['IndexPrimerA708'] = jsonIndexPrimerA708Modified;
		jsonConsumablesModified['IndexPrimerA709'] = jsonIndexPrimerA709Modified;
		jsonConsumablesModified['IndexPrimerA710'] = jsonIndexPrimerA710Modified;
		jsonConsumablesModified['IndexPrimerA711'] = jsonIndexPrimerA711Modified;
		jsonConsumablesModified['IndexPrimerA712'] = jsonIndexPrimerA712Modified;

		jsonConsumablesModified['IndexPrimerA501'] = jsonIndexPrimerA501Modified;
		jsonConsumablesModified['IndexPrimerA502'] = jsonIndexPrimerA502Modified;
		jsonConsumablesModified['IndexPrimerA503'] = jsonIndexPrimerA503Modified;
		jsonConsumablesModified['IndexPrimerA504'] = jsonIndexPrimerA504Modified;
		jsonConsumablesModified['IndexPrimerA505'] = jsonIndexPrimerA505Modified;
		jsonConsumablesModified['IndexPrimerA506'] = jsonIndexPrimerA506Modified;
		jsonConsumablesModified['IndexPrimerA507'] = jsonIndexPrimerA507Modified;
		jsonConsumablesModified['IndexPrimerA508'] = jsonIndexPrimerA508Modified;

		var buttons = Doc.element('detailsSection').getElementsByClassName('edit-details');
		// Add tool tips and click handlers to edit buttons (two buttons per table row)
		for (var i = 0; i < buttons.length; i++)
		{
			// Add tool tip with kit name to button at end of table row
			var kitName = jsonKitName[Math.floor(i/2)];
			var buttonTooltip = kitName;
			if (i%2 == 0)
			{
				buttonTooltip = '';
			}
			var tooltip = [];
			tooltip[tooltip.length] = buttonTooltip;
			buttons[i].title = tooltip.join('\n');
			// Add click handler to button
			Buttons.addClickHandler(buttons[i], exreg.editLibPrepKitDetails);
		}

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gocreate');
		// Disable "Register" button if no data has been changed
		if (!someKitIsModified)
		{
			Doc.addClass('goregister', 'disabled');
		}
		else
		{
			Doc.removeClass('goregister', 'disabled');
		}
		Doc.show('goregister');
		
		Wizard.keepSessionAlive();
	}

	exreg.fetchJsonConsumables = function()
	{
		return jsonConsumables;
	}

	exreg.copyJsonConsumables = function(jsonConsumablesSrc)
	{
		// Get JSONArrays with data for kits

		var jsonHeaders = jsonConsumablesSrc['Headers'];

		var jsonKitName = jsonConsumablesSrc['KitName'];
		var jsonLibraryPrepBox1 = jsonConsumablesSrc['LibraryPrepBox1'];
		var jsonIndexKit = jsonConsumablesSrc['IndexKit'];
		var jsonContentSetBox3 = jsonConsumablesSrc['ContentSetBox3'];
		var jsonOligoPoolA_FPA = jsonConsumablesSrc['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPB = jsonConsumablesSrc['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3 = jsonConsumablesSrc['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1 = jsonConsumablesSrc['StringentWash1_SW1'];
		var jsonExtensionLigationMix3 = jsonConsumablesSrc['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2 = jsonConsumablesSrc['PcrMasterMix2_PMM2'];
		var jsonUB1 = jsonConsumablesSrc['UB1'];
		var jsonTDP = jsonConsumablesSrc['TDP'];
		var jsonFilterplate = jsonConsumablesSrc['Filterplate'];
		
		var jsonIndexPrimerA701 = jsonConsumablesSrc['IndexPrimerA701'];
		var jsonIndexPrimerA702 = jsonConsumablesSrc['IndexPrimerA702'];
		var jsonIndexPrimerA703 = jsonConsumablesSrc['IndexPrimerA703'];
		var jsonIndexPrimerA704 = jsonConsumablesSrc['IndexPrimerA704'];
		var jsonIndexPrimerA705 = jsonConsumablesSrc['IndexPrimerA705'];
		var jsonIndexPrimerA706 = jsonConsumablesSrc['IndexPrimerA706'];
		var jsonIndexPrimerA707 = jsonConsumablesSrc['IndexPrimerA707'];
		var jsonIndexPrimerA708 = jsonConsumablesSrc['IndexPrimerA708'];
		var jsonIndexPrimerA709 = jsonConsumablesSrc['IndexPrimerA709'];
		var jsonIndexPrimerA710 = jsonConsumablesSrc['IndexPrimerA710'];
		var jsonIndexPrimerA711 = jsonConsumablesSrc['IndexPrimerA711'];
		var jsonIndexPrimerA712 = jsonConsumablesSrc['IndexPrimerA712'];
		
		var jsonIndexPrimerA501 = jsonConsumablesSrc['IndexPrimerA501'];
		var jsonIndexPrimerA502 = jsonConsumablesSrc['IndexPrimerA502'];
		var jsonIndexPrimerA503 = jsonConsumablesSrc['IndexPrimerA503'];
		var jsonIndexPrimerA504 = jsonConsumablesSrc['IndexPrimerA504'];
		var jsonIndexPrimerA505 = jsonConsumablesSrc['IndexPrimerA505'];
		var jsonIndexPrimerA506 = jsonConsumablesSrc['IndexPrimerA506'];
		var jsonIndexPrimerA507 = jsonConsumablesSrc['IndexPrimerA507'];
		var jsonIndexPrimerA508 = jsonConsumablesSrc['IndexPrimerA508'];

		var jsonRegistrationDate = jsonConsumablesSrc['RegistrationDate'];
		var jsonLastUpdatedDate = jsonConsumablesSrc['LastUpdatedDate'];
		var jsonExpirationDate = jsonConsumablesSrc['ExpirationDate'];
		var jsonActive = jsonConsumablesSrc['Active'];
		var jsonTimesUsed = jsonConsumablesSrc['TimesUsed'];
		var jsonUnusedFpaPlateLocs = jsonConsumablesSrc['UnusedFpaPlateLocs'];
		var jsonComment = jsonConsumablesSrc['Comment'];

		// Create new JSONArrays for copy

		var jsonHeadersCopy = [];

		var jsonKitNameCopy = [];
		var jsonLibraryPrepBox1Copy = [];
		var jsonIndexKitCopy = [];
		var jsonContentSetBox3Copy = [];
		var jsonOligoPoolA_FPACopy = [];
		var jsonOligoPoolB_FPBCopy = [];
		var jsonOligoHybridizationSequencingReagent3Copy = [];
		var jsonStringentWash1_SW1Copy = [];
		var jsonExtensionLigationMix3Copy = [];
		var jsonPcrMasterMix2_PMM2Copy = [];
		var jsonUB1Copy = [];
		var jsonTDPCopy = [];
		var jsonFilterplateCopy = [];
		
		var jsonIndexPrimerA701Copy = [];
		var jsonIndexPrimerA702Copy = [];
		var jsonIndexPrimerA703Copy = [];
		var jsonIndexPrimerA704Copy = [];
		var jsonIndexPrimerA705Copy = [];
		var jsonIndexPrimerA706Copy = [];
		var jsonIndexPrimerA707Copy = [];
		var jsonIndexPrimerA708Copy = [];
		var jsonIndexPrimerA709Copy = [];
		var jsonIndexPrimerA710Copy = [];
		var jsonIndexPrimerA711Copy = [];
		var jsonIndexPrimerA712Copy = [];
		
		var jsonIndexPrimerA501Copy = [];
		var jsonIndexPrimerA502Copy = [];
		var jsonIndexPrimerA503Copy = [];
		var jsonIndexPrimerA504Copy = [];
		var jsonIndexPrimerA505Copy = [];
		var jsonIndexPrimerA506Copy = [];
		var jsonIndexPrimerA507Copy = [];
		var jsonIndexPrimerA508Copy = [];

		var jsonRegistrationDateCopy = [];
		var jsonLastUpdatedDateCopy = [];
		var jsonExpirationDateCopy = [];
		var jsonActiveCopy = [];
		var jsonTimesUsedCopy = [];
		var jsonUnusedFpaPlateLocsCopy = [];
		var jsonCommentCopy = [];

		// Fill new JSONArrays with data from source
		var numItems = jsonKitName.length;

		for (var i = 0; i < numItems; i++)
		{
			jsonKitNameCopy[i] = jsonKitName[i];
			jsonLibraryPrepBox1Copy[i] = jsonLibraryPrepBox1[i];
			jsonIndexKitCopy[i] = jsonIndexKit[i];
			jsonContentSetBox3Copy[i] = jsonContentSetBox3[i];
			jsonOligoPoolA_FPACopy[i] = jsonOligoPoolA_FPA[i];
			jsonOligoPoolB_FPBCopy[i] = jsonOligoPoolB_FPB[i];
			jsonOligoHybridizationSequencingReagent3Copy[i] = jsonOligoHybridizationSequencingReagent3[i];
			jsonStringentWash1_SW1Copy[i] = jsonStringentWash1_SW1[i];
			jsonExtensionLigationMix3Copy[i] = jsonExtensionLigationMix3[i];
			jsonPcrMasterMix2_PMM2Copy[i] = jsonPcrMasterMix2_PMM2[i];
			jsonUB1Copy[i] = jsonUB1[i];
			jsonTDPCopy[i] = jsonTDP[i];
			jsonFilterplateCopy[i] = jsonFilterplate[i];
		
			jsonIndexPrimerA701Copy[i] = jsonIndexPrimerA701[i];
			jsonIndexPrimerA702Copy[i] = jsonIndexPrimerA702[i];
			jsonIndexPrimerA703Copy[i] = jsonIndexPrimerA703[i];
			jsonIndexPrimerA704Copy[i] = jsonIndexPrimerA704[i];
			jsonIndexPrimerA705Copy[i] = jsonIndexPrimerA705[i];
			jsonIndexPrimerA706Copy[i] = jsonIndexPrimerA706[i];
			jsonIndexPrimerA707Copy[i] = jsonIndexPrimerA707[i];
			jsonIndexPrimerA708Copy[i] = jsonIndexPrimerA708[i];
			jsonIndexPrimerA709Copy[i] = jsonIndexPrimerA709[i];
			jsonIndexPrimerA710Copy[i] = jsonIndexPrimerA710[i];
			jsonIndexPrimerA711Copy[i] = jsonIndexPrimerA711[i];
			jsonIndexPrimerA712Copy[i] = jsonIndexPrimerA712[i];
		
			jsonIndexPrimerA501Copy[i] = jsonIndexPrimerA501[i];
			jsonIndexPrimerA502Copy[i] = jsonIndexPrimerA502[i];
			jsonIndexPrimerA503Copy[i] = jsonIndexPrimerA503[i];
			jsonIndexPrimerA504Copy[i] = jsonIndexPrimerA504[i];
			jsonIndexPrimerA505Copy[i] = jsonIndexPrimerA505[i];
			jsonIndexPrimerA506Copy[i] = jsonIndexPrimerA506[i];
			jsonIndexPrimerA507Copy[i] = jsonIndexPrimerA507[i];
			jsonIndexPrimerA508Copy[i] = jsonIndexPrimerA508[i];

			jsonRegistrationDateCopy[i] = jsonRegistrationDate[i];
			jsonLastUpdatedDateCopy[i] = jsonLastUpdatedDate[i];
			jsonExpirationDateCopy[i] = jsonExpirationDate[i];
			jsonActiveCopy[i] = jsonActive[i];
			jsonTimesUsedCopy[i] = jsonTimesUsed[i];
			jsonUnusedFpaPlateLocsCopy[i] = jsonUnusedFpaPlateLocs[i];
			jsonCommentCopy[i] = jsonComment[i];
		}

		// Create new JSONObject for copy

		var jsonConsumablesCopy = {};

		// Fill new JSONObject with data from source
		jsonConsumablesCopy['KitName'] = jsonKitNameCopy;
		jsonConsumablesCopy['LibraryPrepBox1'] = jsonLibraryPrepBox1Copy;
		jsonConsumablesCopy['IndexKit'] = jsonIndexKitCopy;
		jsonConsumablesCopy['ContentSetBox3'] = jsonContentSetBox3Copy;
		jsonConsumablesCopy['OligoPoolA_FPA'] = jsonOligoPoolA_FPACopy;
		jsonConsumablesCopy['OligoPoolB_FPB'] = jsonOligoPoolB_FPBCopy;
		jsonConsumablesCopy['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3Copy;
		jsonConsumablesCopy['StringentWash1_SW1'] = jsonStringentWash1_SW1Copy;
		jsonConsumablesCopy['ExtensionLigationMix3'] = jsonExtensionLigationMix3Copy;
		jsonConsumablesCopy['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2Copy;
		jsonConsumablesCopy['UB1'] = jsonUB1Copy;
		jsonConsumablesCopy['TDP'] = jsonTDPCopy;
		jsonConsumablesCopy['Filterplate'] = jsonFilterplateCopy;

		jsonConsumablesCopy['IndexPrimerA701'] = jsonIndexPrimerA701Copy;
		jsonConsumablesCopy['IndexPrimerA702'] = jsonIndexPrimerA702Copy;
		jsonConsumablesCopy['IndexPrimerA703'] = jsonIndexPrimerA703Copy;
		jsonConsumablesCopy['IndexPrimerA704'] = jsonIndexPrimerA704Copy;
		jsonConsumablesCopy['IndexPrimerA705'] = jsonIndexPrimerA705Copy;
		jsonConsumablesCopy['IndexPrimerA706'] = jsonIndexPrimerA706Copy;
		jsonConsumablesCopy['IndexPrimerA707'] = jsonIndexPrimerA707Copy;
		jsonConsumablesCopy['IndexPrimerA708'] = jsonIndexPrimerA708Copy;
		jsonConsumablesCopy['IndexPrimerA709'] = jsonIndexPrimerA709Copy;
		jsonConsumablesCopy['IndexPrimerA710'] = jsonIndexPrimerA710Copy;
		jsonConsumablesCopy['IndexPrimerA711'] = jsonIndexPrimerA711Copy;
		jsonConsumablesCopy['IndexPrimerA712'] = jsonIndexPrimerA712Copy;

		jsonConsumablesCopy['IndexPrimerA501'] = jsonIndexPrimerA501Copy;
		jsonConsumablesCopy['IndexPrimerA502'] = jsonIndexPrimerA502Copy;
		jsonConsumablesCopy['IndexPrimerA503'] = jsonIndexPrimerA503Copy;
		jsonConsumablesCopy['IndexPrimerA504'] = jsonIndexPrimerA504Copy;
		jsonConsumablesCopy['IndexPrimerA505'] = jsonIndexPrimerA505Copy;
		jsonConsumablesCopy['IndexPrimerA506'] = jsonIndexPrimerA506Copy;
		jsonConsumablesCopy['IndexPrimerA507'] = jsonIndexPrimerA507Copy;
		jsonConsumablesCopy['IndexPrimerA508'] = jsonIndexPrimerA508Copy;

		jsonConsumablesCopy['RegistrationDate'] = jsonRegistrationDateCopy;
		jsonConsumablesCopy['LastUpdatedDate'] = jsonLastUpdatedDateCopy;
		jsonConsumablesCopy['ExpirationDate'] = jsonExpirationDateCopy;
		jsonConsumablesCopy['Active'] = jsonActiveCopy;
		jsonConsumablesCopy['TimesUsed'] = jsonTimesUsedCopy;
		jsonConsumablesCopy['UnusedFpaPlateLocs'] = jsonUnusedFpaPlateLocsCopy;
		jsonConsumablesCopy['Comment'] = jsonCommentCopy;

		return jsonConsumablesCopy;
	}

	exreg.libPrepKitDataToJsonArray = function()
	{
		// Reset JSONArray
		jsonKitArray = [];

		// Get JSONArrays with data for kits
		// One kit component a time, e.g. 'jsonKitName' is a JSONArray with kit names
 
		var jsonHeaders = jsonConsumables['Headers'];

		var jsonKitName = jsonConsumables['KitName'];
		var jsonLibraryPrepBox1 = jsonConsumables['LibraryPrepBox1'];
		var jsonIndexKit = jsonConsumables['IndexKit'];
		var jsonContentSetBox3 = jsonConsumables['ContentSetBox3'];
		var jsonOligoPoolA_FPA = jsonConsumables['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPB = jsonConsumables['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3 = jsonConsumables['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1 = jsonConsumables['StringentWash1_SW1'];
		var jsonExtensionLigationMix3 = jsonConsumables['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2 = jsonConsumables['PcrMasterMix2_PMM2'];
		var jsonUB1 = jsonConsumables['UB1'];
		var jsonTDP = jsonConsumables['TDP'];
		var jsonFilterplate = jsonConsumables['Filterplate'];
		
		var jsonIndexPrimerA701 = jsonConsumables['IndexPrimerA701'];
		var jsonIndexPrimerA702 = jsonConsumables['IndexPrimerA702'];
		var jsonIndexPrimerA703 = jsonConsumables['IndexPrimerA703'];
		var jsonIndexPrimerA704 = jsonConsumables['IndexPrimerA704'];
		var jsonIndexPrimerA705 = jsonConsumables['IndexPrimerA705'];
		var jsonIndexPrimerA706 = jsonConsumables['IndexPrimerA706'];
		var jsonIndexPrimerA707 = jsonConsumables['IndexPrimerA707'];
		var jsonIndexPrimerA708 = jsonConsumables['IndexPrimerA708'];
		var jsonIndexPrimerA709 = jsonConsumables['IndexPrimerA709'];
		var jsonIndexPrimerA710 = jsonConsumables['IndexPrimerA710'];
		var jsonIndexPrimerA711 = jsonConsumables['IndexPrimerA711'];
		var jsonIndexPrimerA712 = jsonConsumables['IndexPrimerA712'];
		
		var jsonIndexPrimerA501 = jsonConsumables['IndexPrimerA501'];
		var jsonIndexPrimerA502 = jsonConsumables['IndexPrimerA502'];
		var jsonIndexPrimerA503 = jsonConsumables['IndexPrimerA503'];
		var jsonIndexPrimerA504 = jsonConsumables['IndexPrimerA504'];
		var jsonIndexPrimerA505 = jsonConsumables['IndexPrimerA505'];
		var jsonIndexPrimerA506 = jsonConsumables['IndexPrimerA506'];
		var jsonIndexPrimerA507 = jsonConsumables['IndexPrimerA507'];
		var jsonIndexPrimerA508 = jsonConsumables['IndexPrimerA508'];

		var jsonRegistrationDate = jsonConsumables['RegistrationDate'];
		var jsonLastUpdatedDate = jsonConsumables['LastUpdatedDate'];
		var jsonExpirationDate = jsonConsumables['ExpirationDate'];
		var jsonActive = jsonConsumables['Active'];
		var jsonTimesUsed = jsonConsumables['TimesUsed'];
		var jsonUnusedFpaPlateLocs = jsonConsumables['UnusedFpaPlateLocs'];
		var jsonComment = jsonConsumables['Comment'];

		// Get JSONArrays with data for kits
		// One kit a time, e.g. 'jsonKitArray' is a JSONArray with one JSONObject for each kit

		var numItems = jsonKitName.length;

		for (var i = 0; i < numItems; i++)
		{
			// Store data for kit number 'i' in JSONObject 'jsonKit'
			var jsonKit = {};

			jsonKit['KitName'] = jsonKitName[i];
			jsonKit['LibraryPrepBox1'] = jsonLibraryPrepBox1[i];
			jsonKit['IndexKit'] = jsonIndexKit[i];
			jsonKit['ContentSetBox3'] = jsonContentSetBox3[i];
			jsonKit['OligoPoolA_FPA'] = jsonOligoPoolA_FPA[i];
			jsonKit['OligoPoolB_FPB'] = jsonOligoPoolB_FPB[i];
			jsonKit['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3[i];
			jsonKit['StringentWash1_SW1'] = jsonStringentWash1_SW1[i];
			jsonKit['ExtensionLigationMix3'] = jsonExtensionLigationMix3[i];
			jsonKit['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2[i];
			jsonKit['UB1'] = jsonUB1[i];
			jsonKit['TDP'] = jsonTDP[i];
			jsonKit['Filterplate'] = jsonFilterplate[i];
		
			jsonKit['IndexPrimerA701'] = jsonIndexPrimerA701[i];
			jsonKit['IndexPrimerA702'] = jsonIndexPrimerA702[i];
			jsonKit['IndexPrimerA703'] = jsonIndexPrimerA703[i];
			jsonKit['IndexPrimerA704'] = jsonIndexPrimerA704[i];
			jsonKit['IndexPrimerA705'] = jsonIndexPrimerA705[i];
			jsonKit['IndexPrimerA706'] = jsonIndexPrimerA706[i];
			jsonKit['IndexPrimerA707'] = jsonIndexPrimerA707[i];
			jsonKit['IndexPrimerA708'] = jsonIndexPrimerA708[i];
			jsonKit['IndexPrimerA709'] = jsonIndexPrimerA709[i];
			jsonKit['IndexPrimerA710'] = jsonIndexPrimerA710[i];
			jsonKit['IndexPrimerA711'] = jsonIndexPrimerA711[i];
			jsonKit['IndexPrimerA712'] = jsonIndexPrimerA712[i];
		
			jsonKit['IndexPrimerA501'] = jsonIndexPrimerA501[i];
			jsonKit['IndexPrimerA502'] = jsonIndexPrimerA502[i];
			jsonKit['IndexPrimerA503'] = jsonIndexPrimerA503[i];
			jsonKit['IndexPrimerA504'] = jsonIndexPrimerA504[i];
			jsonKit['IndexPrimerA505'] = jsonIndexPrimerA505[i];
			jsonKit['IndexPrimerA506'] = jsonIndexPrimerA506[i];
			jsonKit['IndexPrimerA507'] = jsonIndexPrimerA507[i];
			jsonKit['IndexPrimerA508'] = jsonIndexPrimerA508[i];

			jsonKit['RegistrationDate'] = jsonRegistrationDate[i];
			jsonKit['LastUpdatedDate'] = jsonLastUpdatedDate[i];
			jsonKit['ExpirationDate'] = jsonExpirationDate[i];
			jsonKit['Active'] = jsonActive[i];
			jsonKit['TimesUsed'] = jsonTimesUsed[i];
			jsonKit['UnusedFpaPlateLocs'] = jsonUnusedFpaPlateLocs[i];
			jsonKit['Comment'] = jsonComment[i];

			// Add JSONObject 'jsonKit' with data for kit number 'i' to JSONArray 'jsonKitArray'
			jsonKitArray[i] = jsonKit;			
		}
	}

	exreg.editLibPrepKitDetails = function(event)
	{
		// 'index' is row value in table, starting with 0
		var index = Data.get(event.currentTarget, 'index');
		var frm = document.forms['meludi'];
		var jsonKitName = jsonConsumables['KitName'];
		var kitName = jsonKitName[index];
		var url = 'edit_libprep_kit_details.jsp?ID='+App.getSessionId();
		url += '&index='+index;
		//url += '&mode=' + 'LibPrepKitEdit';
		url += '&kitname=' + kitName;
		Dialogs.openPopup(url, 'EditLibPrepKitDetails'+index, 750, 500);	
	}

	exreg.downloadLibPrepKitDataFile = function()
	{
		var frm = document.forms['meludi'];
		var kitFilterValue = frm.libPrepKitFilter.value;
		var kitFilterName = exreg.fetchLibPrepFilterName(kitFilterValue);
		var numItemsFiltered = jsonConsumables['numItemsFiltered'];
		var numItemsTot = jsonConsumables['numItemsTot'];
		var reagentInfo = {};

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=PrepareDownloadLibPrepKitDataFile';
		url += '&kitFilter='+encodeURIComponent(kitFilterValue);
		url += '&kitFilterName='+encodeURIComponent(kitFilterName);
		url += '&numItemsFiltered='+encodeURIComponent(numItemsFiltered);
		url += '&numItemsTot='+encodeURIComponent(numItemsTot);

		// Reagents
		reagentInfo = jsonConsumables;

		// POST
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.downloadLibPrepKitDataFileResults, 'POST', JSON.stringify(reagentInfo));
	}

	exreg.downloadLibPrepKitDataFileResults = function(response)
	{
		var tmpFilePath = response;
		var frm = document.forms['meludi'];
		var kitFilterValue = frm.libPrepKitFilter.value;

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadLibPrepKitDataFile';
		url += '&kitFilterValue='+encodeURIComponent(kitFilterValue);
		url += '&tmpFilePath='+encodeURIComponent(tmpFilePath);
		window.open(url);
	}

	exreg.validateStep2 = function(event)
	{
		var valid = true;
		valid &= consumablesFileIsValid;
		
//alert("exreg.validateStep2(): valid = " + valid);
		if (!valid) event.preventDefault();
	}

	exreg.submit = function()
	{
		var frm = document.forms['meludi'];
		
		var submitInfo = {};
		submitInfo = jsonConsumablesModified;

		// Library preparation reagent file
/*
		submitInfo.referenceName = frm.consumablesFile.value;
		submitInfo.expirationDate = frm.expirationDate.value;
*/

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterKits';
		url += '&overwrite=true';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	exreg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
/*
		Doc.show('gocreate');
*/
	}

	exreg.createProtocol = function()
	{
		var frm = document.forms['meludi'];
		var submitInfo = {};
		submitInfo.items = [];

		submitInfo.docMode = 'report';
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var totNumItems = numItems;
		for (var i = 0; i < totNumItems; i++)
		{
			var item = null;
			item = selItemsList[i];
			submitInfo.items[submitInfo.items.length] = item;
		}

		// Extraction
		submitInfo.startListName = frm.startListName.value;
		submitInfo.isolationDate = frm.isolationDate.value;
		submitInfo.extractionOperator = frm.extractionOperator.value;
		submitInfo.extractionProtocol = parseInt(frm.extractionProtocolId.value, 10);
		var extractionProtocolName = frm.extractionProtocolName.value;
		var protocolVersionNo = '';
		if (extractionProtocolName)
		{
			protocolVersionNo = extractionProtocolName;
			// Remove part of string up to and including last "v"
			var vIndex = protocolVersionNo.indexOf('v');
			while (vIndex >= 0)
			{
				// Remove part of string up to and including first "v"
				protocolVersionNo = protocolVersionNo.substring(vIndex + 1);
				vIndex = protocolVersionNo.indexOf('v');
			}
		}
		var protocolPreviewFlag = null;
		if (trackingProtocolPreview)
		{
			protocolPreviewFlag = 'true';
		}
		submitInfo.extractionProtocolName = extractionProtocolName;
		submitInfo.protocolVersionNo = protocolVersionNo;
		submitInfo.protocolPreviewFlag = protocolPreviewFlag;
		submitInfo.dnaDefaultVolume = ExtractUtils.getNumber(frm.dnaDefaultVolume.value);
		
		// QIAcube
		submitInfo.qiacubeDate = frm.qiacubeDate.value;
		submitInfo.qiacubeOperator = frm.qiacubeOperator.value;
		submitInfo.qiacubeRunNo = parseInt(frm.qiacubeRunNo.value, 10);

		// Specimen reagents
		submitInfo.xyleneSpecimen = frm.xyleneSpecimen.value;
		submitInfo.etoh995Specimen = frm.etoh995Specimen.value;
		submitInfo.allPrepFfpeKit = frm.allPrepFfpeKit.value;
		submitInfo.bufferPkdSpecimen = frm.bufferPkdSpecimen.value;
		submitInfo.bufferAtlSpecimen = frm.bufferAtlSpecimen.value;
		submitInfo.proteinaseKSpecimen = frm.proteinaseKSpecimen.value;
		submitInfo.rnaseASpecimen = frm.rnaseASpecimen.value;

		// QIAcube
		submitInfo.etoh995 = frm.etoh995.value;
		submitInfo.bufferRlt = frm.bufferRlt.value;
		submitInfo.bufferFrn = frm.bufferFrn.value;
		submitInfo.bufferRpe = frm.bufferRpe.value;
		submitInfo.bufferAl = frm.bufferAl.value;
		submitInfo.bufferAw1 = frm.bufferAw1.value;
		submitInfo.bufferAw2 = frm.bufferAw2.value;
		submitInfo.bufferAte = frm.bufferAte.value;
		submitInfo.bufferRdd = frm.bufferRdd.value;
		submitInfo.rnaseFreeWater = frm.rnaseFreeWater.value;
		submitInfo.dnaseMix = frm.dnaseMix.value;
		submitInfo.rneasyMinEluteSpinColumn = frm.rneasyMinEluteSpinColumn.value;
		submitInfo.qiaampMinEluteSpinColumn = frm.qiaampMinEluteSpinColumn.value;

		// Quality control reagents
		submitInfo.kapaSybrFast = frm.kapaSybrFast.value;
		submitInfo.qualityControlPrimersQcpRgt = frm.qualityControlPrimersQcpRgt.value;
		submitInfo.qualityControlTemplateQct = frm.qualityControlTemplateQct.value;
		submitInfo.qubitDnaHighSens = frm.qubitDnaHighSens.value;
		submitInfo.qubitDnaBroadRange = frm.qubitDnaBroadRange.value;

		// Save values in hidden input fields for retrieval after HTML request
		var submitInfoJsonStr = JSON.stringify(submitInfo);
		frm.hiddenSubmitInfo.value = submitInfoJsonStr;
		frm.hiddenNumItems.value = submitInfo.items.length;
		frm.hiddenCounterBalanceInfoRow.value = counterBalanceInfoRow;

		// Calling frm.submit() will change jsp file to extraction_protocol2.jsp
		frm.submit();
	}

	exreg.fetchLibPrepFilterName = function(filterValue)
	{
		var filterName = filterValue;
		if (filterValue != null && filterValue != '')
		{
			if (filterValue == 'all')
			{
				filterName = 'All';
			}
			else if (filterValue == 'used_active')
			{
				filterName = 'Used & active';
			}
			else if (filterValue == 'used_inactive')
			{
				filterName = 'Used & inactive';
			}
			else if (filterValue == 'used')
			{
				filterName = 'Used';
			}
			else if (filterValue == 'unused')
			{
				filterName = 'Unused';
			}
			else if (filterValue == 'active')
			{
				filterName = 'Active';
			}
			else if (filterValue == 'inactive')
			{
				filterName = 'Inactive';
			}
		}
		return filterName;
	}

	return exreg;
}();

Doc.onLoad(ExtractionReg.initPage);

